package w2.ex3.creatures.ex;

import java.util.List;
import java.util.ArrayList;

public class Gang {
	private List<Creature> members;

	public Gang(int size) {
		members = new ArrayList<Creature>(size);
	}

	public void add(Creature m) {
		members.add(m);
	}

	public boolean remove(Creature m) {
		return members.remove(m);
	}

	public int damageSum() {
		int total = 0;

		for (Creature c : members) {
			if (c != null) {
				int energy = c.getEnergy();
				switch (c.getType()) {
				case SNAKE:
					total += 10 * energy;
					break;
				case GOBLIN:
					total += 4 * energy * energy;
					break;
				case SPIDER:
					if (energy > 5) total += 100;
					break;
				}
			}
		}

		return total;
	}

	public static void main(String[] args) {
		Creature snake =
			new Creature("Sour Serpent",
					Creature.Type.SNAKE);
		Creature goblin =
			new Creature("Greasy Goblin",
					Creature.Type.GOBLIN);
		Creature spider =
			new Creature("Spicy Spider",
					Creature.Type.SPIDER);
		Gang gang = new Gang(3);
		gang.add(snake);
		gang.add(spider);
		gang.add(goblin);
		System.out.println("Collective damage: " +
				gang.damageSum());
	}
}
